/* This file is Copyright 2001 Level Control Systems.  See the included LICENSE.txt file for details. */

#ifndef _CONVERTMESSAGES_H
#define _CONVERTMESSAGES_H

#include <app/Message.h>
#include "message/PortableMessage.h"

/*
 *   Functions to convert BMessages to PortableMessages and back.
 *   This code will only compile under BeOS!
 */

/** Converts a PortableMessage into a BMessage.  Only compiles under BeOS! 
 *  @param from the PortableMessage you wish to convert
 *  @param to the BMessage to write the result into
 *  @return B_NO_ERROR if the conversion succeeded, or B_ERROR if it failed.
 */
status_t ConvertPortableMessageToBMessage(const PortableMessage & from, BMessage & to);

/** Converts a BMessage into a PortableMessage.  Only compiles under BeOS! 
 *  @param from the BMessage you wish to convert
 *  @param to the PortableMessage to write the result into
 *  @return B_NO_ERROR if the conversion succeeded, or B_ERROR if it failed.
 */
status_t ConvertBMessageToPortableMessage(const BMessage & from, PortableMessage & to);

#endif
